// 004 u_ib_dbx_add_index
// 15 oct 2004

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_ib_dbx_add_index;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Db, DBTables, Grids, DBGrids, ComCtrls,
  DBXpress, FMTBcd, SqlExpr
  , IBDatabase
  ;

type
  TForm1 = class(TForm)
    Panel2: TPanel;
    add_index_: TButton;
    drop_index_: TButton;
    Panel1: TPanel;
    Memo1: TMemo;
    SQLConnection1: TSQLConnection;
    SQLQuery1: TSQLQuery;
    alter_: TButton;
    not_null_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure add_index_Click(Sender: TObject);
    procedure drop_index_Click(Sender: TObject);
    procedure alter_Click(Sender: TObject);
    procedure not_null_Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation
  uses u_c_log, u_c_display
    ;

{$R *.DFM}


    // k_connection_string= 127.0.0.1:C:\programs\interbase\data\Institut_Pascal.GDB

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.add_index_Click(Sender: TObject);
      begin
        with SqlQuery1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add('CREATE INDEX x_numero ON formations (f_numero)');
          end; // with Sql

          display_strings(Sql);

          Try
            SqlConnection1.Open;

            ExecSql;

            display('  ok');
          except
            on e: Exception do
              begin
                display('  *** pb_create '+ e.Message);
              end;
          end;
        end; // with SqlQuery1
      end; // create_table_Click

    procedure TForm1.drop_index_Click(Sender: TObject);
      begin
        with SQLQuery1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add('DROP INDEX x_numero');
            display_strings(Sql);

            Try
              ExecSql;
              display('  ok');
            except
              on e: Exception do
                display('  *** pb '+ e.Message);
            end;
          end; // with Sql
        end; // with SQLQuery1
      end; // drop_table_Click

    procedure TForm1.alter_Click(Sender: TObject);
      begin
        with SqlQuery1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add('ALTER TABLE formations ADD CONSTRAINT k_key_numero PRIMARY KEY (f_numero)');
          end; // with Sql

          display_strings(Sql);

          Try
            SqlConnection1.Open;

            ExecSql;

            display('  ok');
          except
            on e: Exception do
              begin
                display('  *** pb_create '+ e.Message);
              end;
          end;
        end; // with SqlQuery1
      end;

    procedure TForm1.not_null_Click(Sender: TObject);
      begin
        with SqlQuery1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            // Add('ALTER TABLE formations ALTER COLUMN f_numero ADD CONSTRAINT k_key_numer_not_null NOT NULL');
            // Add('ALTER TABLE formations ALTER COLUMN f_numero NOT NULL');
            Add('ALTER TABLE formations ALTER COLUMN f_numero CONSTRAINT NOT NULL');
          end; // with Sql

          display_strings(Sql);

          Try
            SqlConnection1.Open;

            ExecSql;

            display('  ok');
          except
            on e: Exception do
              begin
                display('  *** pb_create '+ e.Message);
              end;
          end;
        end; // with SqlQuery1
      end;

end.


